/*
 * Copyright (C) 2009 - 2019 Xilinx, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
 * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include "xparameters.h"
#include "platform.h"
#include "platform_config.h"
#if defined (__arm__) || defined(__aarch64__)
#include "xil_printf.h"
#endif

#include "xil_cache.h"

#include "GPIO_Driv.h"
#include "SPI_Driv.h"
#include "cal_meas.h"
#include "uart_IO.h"

#include "lwip/tcp.h"
extern void tcp_tmr(void);  /* declared in tcp_priv.h, not in public tcp.h */
#include "xil_cache.h"

#if LWIP_DHCP==1
	#include "lwip/dhcp.h"
#endif

u8 recvbuffer[1024] = {0};

/* defined by each RAW mode application */
void print_app_header();
int start_application();
int transfer_data();

/* missing declaration in lwIP */
void lwip_init();

#if LWIP_IPV6==0
	#if LWIP_DHCP==1
		extern volatile int dhcp_timoutcntr;
		err_t dhcp_start(struct netif *netif);
	#endif
#endif

static struct netif server_netif;
struct netif *echo_netif;

int main()
{
	int iMainCom = 1;

	init_platform();

	xil_printf("=====================\r\n[I] System Init Done!\r\n");
	
	xil_printf("[D] Start EMIO Config\r\n");
	EMIO_config();
	xil_printf("[D] End of EMIO Config\r\n");

	xil_printf("[D] Start CPLD Reset\r\n");
	rst_CPLD(CPLD_U1,4);
	rst_CPLD(CPLD_U2,4);
	rst_CPLD(CPLD_U3,4);
	xil_printf("[D] End of CPLD Reset\r\n");

	xil_printf("[D] Config CPLD SPI to known state\r\n");
	interface_initial(CPLD_U1);
	interface_initial(CPLD_U2);
	interface_initial(CPLD_U3);



	xil_printf("[I] Board Init Complete!\r\n[I] Waiting for Command...\r\n");
	/* receive and process Instructions */
	while (1) 
	{
		int Status = -255;
		Status = UART_RecvInstr(recvbuffer);
		if (Status < 0)
		{
			xil_printf("[E] UART Receive ERROR!!! Check PrintOut Ahead\r\n");
		}
		else if (Status > 0)
		{
			Command_Parser(recvbuffer,Status);		//Here Status should equal to length
		}
		
	}

	/* never reached */
	cleanup_platform();

	return 0;
}

